獲取AutoCAD中.Net程序定義的命令——Through the Interface

原文:Getting the list of .NET-defined commands in AutoCAD

Kerry Brown提出了一個有趣的問題:

有沒有一種辦法來確定從託管代碼加載到Acad中的命令…是一個全局列表或與一個特定的組件相關的列表…或着兩者都有:-)

我設法把一些代碼組合到一起來實現這個功能(雖然我需要考慮如何AutoCAD是如何做到的來實現某些細節)。我選擇了實現兩種類型的命令——一是獲取所有的加載的程序集的命令,另一個只是對當前正在執行的程序集有效。但是第一個命令執行的相當緩慢,因爲它需要花時間來查詢每個加載的組件-所以我增加了一個命令,只能查詢顯式聲明過CommandClass屬性的組件。

我沒有寫查詢特定組件定義的命令,這作爲留給讀者的練習。:-)

以下是C#代碼

using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.EditorInput;
using Autodesk.AutoCAD.Runtime;
using System;
using System.Reflection;
using System.Collections.Specialized;

namespace GetLoadedCommands
{
  public class Commands
  {
    [CommandMethod("TC")]
    static public void ListCommandsFromThisAssembly()
    {
      // Just get the commands for this assembly

      DocumentCollection dm =
        Application.DocumentManager;
      Editor ed =
        dm.MdiActiveDocument.Editor;

      Assembly asm =
        Assembly.GetExecutingAssembly();
      string[] cmds = GetCommands(asm, false);
      foreach (string cmd in cmds)
      {
        ed.WriteMessage(cmd + "\n");
      }
    }

    [CommandMethod("LCM")]
    static public void ListMarkedCommands()
    {
      // Get the commands for all assemblies,
      //  but only those with explicit
      // CommandClass attributes (much quicker)

      StringCollection cmds = new StringCollection();
      DocumentCollection dm =
        Application.DocumentManager;
      Editor ed =
        dm.MdiActiveDocument.Editor;

      Assembly[] asms =
        AppDomain.CurrentDomain.GetAssemblies();
      foreach (Assembly asm in asms)
      {
        cmds.AddRange(GetCommands(asm, true));
      }
      foreach (string cmd in cmds)
      {
        ed.WriteMessage(cmd + "\n");
      }
    }

    [CommandMethod("LC")]
    static public void ListCommands()
    {
      // Get the commands for all assemblies,
      // marked or otherwise (much slower)

      StringCollection cmds = new StringCollection();
      DocumentCollection dm =
        Application.DocumentManager;
      Editor ed =
        dm.MdiActiveDocument.Editor;

      Assembly[] asms =
        AppDomain.CurrentDomain.GetAssemblies();
      foreach (Assembly asm in asms)
      {
        cmds.AddRange(GetCommands(asm, false));
      }
      foreach (string cmd in cmds)
      {
        ed.WriteMessage(cmd + "\n");
      }
    }

    private static string[] GetCommands(
      Assembly asm,
      bool markedOnly
    )
    {
      StringCollection sc = new StringCollection();
      object[] objs =
        asm.GetCustomAttributes(
          typeof(CommandClassAttribute),
          true
        );
      Type[] tps;
      int numTypes = objs.Length;
      if (numTypes > 0)
      {
        tps = new Type[numTypes];
        for(int i=0; i < numTypes; i++)
        {
          CommandClassAttribute cca =
            objs[i] as CommandClassAttribute;
          if (cca != null)
          {
            tps[i] = cca.Type;
          }
        }
      }
      else
      {
        // If we're only looking for specifically
        // marked CommandClasses, then use an
        // empty list
        if (markedOnly)
          tps = new Type[0];
        else
          tps = asm.GetExportedTypes();
      }

      foreach (Type tp in tps)
      {
        MethodInfo[] meths = tp.GetMethods();
        foreach (MethodInfo meth in meths)
        {
          objs =
            meth.GetCustomAttributes(
              typeof(CommandMethodAttribute),
              true
            );
          foreach (object obj in objs)
          {
            CommandMethodAttribute attb =
              (CommandMethodAttribute)obj;
            sc.Add(attb.GlobalName);
          }
        }
      }
      string[] ret = new string[sc.Count];
      sc.CopyTo(ret,0);
      return ret;
    }
  }
}

發佈了10 篇原創文章 · 獲贊 13 · 訪問量 9萬+
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章